<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8"/>
<title>Shokado Web Sharing Tool for Bento</title>
<style type="text/css">
body {background-color:#f9f9f9;	font-family:Helvetica, Arial, sans-serif; font-size:11px; margin-left:1px;margin-top:1px;}
th {background-color:#e9e9e9; text-align:left;	font-family:Helvetica, Arial, sans-serif; font-size:11px;}
th.thsort { cursor:pointer;cursor:hand;}
td {vertical-align:top;font-family:Helvetica, Arial, sans-serif;font-size:11px;}
td.td_1 {background-color:#FFFFFF;}
td.copy {background-color:#FFFFFF;font-size:9px;}
table {border-collapse:collapse;}
a {	font-size:12px;	font-weight:bold;color:black;}
a.coll {font-size:11px;}
a.item{	font-size:11px;	font-weight:normal; color:black}
#libname {font-family:ComicSansMS, Helvetica, Arial, sans-serif;padding-top:2px;padding-left:4px;height:34px;margin-bottom:2px;background-color:#616367;color:white;font-size:24px;} 
</style>
<script src="sorttable.js"></script>
<script language="javascript">
function showform(record,library,libid,collid) {
	var url = 'form.php?id='+record+'&lib='+library+'&libid='+libid+'&collid='+collid;
	frmWindow = window.open (url,'frmwindow','height=600,width=800,status=0,toolbar=0,resizable=1,scrollbars=1');
}
</script>
</head>
<body>
<?php
/*
This file is part of Shokado Web Sharing Tool for Bento.

Shokado Web Sharing Tool for Bento is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.

Shokado Web Sharing Tool for Bento is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along withShokado Web Sharing Tool for Bento.  If not, see <http://www.gnu.org/licenses/>.
*/

// ----------------------------------------------------------------------------------
// Modify the config.php  file to match your configuration
// ----------------------------------------------------------------------------------

error_reporting(E_ALL);
ini_set("display_errors", 1);
include ("config.php");
include ("version.php");

//Connect to the database, try to select a table
$db = new PDO($bentoDB,0666,&$error);
$checkdbresult = $db->query("PRAGMA table_info(gn_domain)");
if ($row = $checkdbresult->fetch(PDO::FETCH_ASSOC)===false) {
	echo "Unable to connect!";
	exit;
}
//Gets the image for the library.  If needed extracts image data from the Bento Application bundle
function GetLibraryImage($libID,$libtype,$iconSet) {
	global $libraryImageName;
	
	
	$libraryFileName = getcwd() . "/". $libraryImageName;
	if (file_exists($libraryFileName)){
		return;
	}
	else {
		include_once("getimage.php");
		if (!GetImageFromResources($libID,$iconSet, $libtype)) {
			$libraryImageName="sysimages/GenericLibrary.tif";	
		 };
	}
}
//Gets the image for the collection.  If needed extracts image data from the database
function GetCollectionImage($libID,$libtype,$libIconSet) {
	global $collectionImageName;
	$collectionFileName = getcwd() . "/". $collectionImageName;
	if (file_exists($collectionFileName)){
		return;
	}
	else {
		include_once("getimage.php");
		if (!GetImageFromResources($libID,$libtype,$libIconSet)) {
			$collectionImageName="sysimages/GenericCollection.tif";
		}
	}
}
//Converts a CoreData timestamp to the local date
function phpDate($cdDate)
{
 	if (strlen($cdDate)==0) return "<span style=\"display:none\">00/00/0000</span>";
 	
  	$testDate  = mktime(0,0,0,1,1,2001);
   	$gmtoffset = date('Z');
  	$addseconds = $cdDate + $testDate + $gmtoffset;
  	$hrDate = date("m/d/Y",$addseconds);
  	
  	return $hrDate; 
}
//Converts a CoreData timestamp to the local date
function phpDateTime($cdDate)
{
 	if (strlen($cdDate)==0) return "<span style=\"display:none\">00/00/0000</span>";
 	
  	$testDate  = mktime(0,0,0,1,1,2001);
   	$gmtoffset = date('Z');
  	$addseconds = $cdDate + $testDate + $gmtoffset;
  	$hrDate = date("m/d/Y h:i A",$addseconds);
  	
  	return $hrDate; 
}
//Converts a checkbox field
function phpCB($cbVal)
{
	$cbstr = "<input disabled type=checkbox";
 	if ($cbVal=="1.0") $cbstr.=" checked";
 	$cbstr.=">";
 	
  	return $cbstr;
}
//Set defaults
$libID = -1;
$collID = -1;
$libName = "";
$collName = "";
$libraryImageName ="";
$collectionImageName ="";
$imageType="";
//See if passed anything on the post
if (isset($_GET["lib"])) {
	$libID = $_GET["lib"];
}
if (isset($_GET["coll"])) {
	$collID = $_GET["coll"];
}
//Create table and get libraries
echo "<table cellspacing=5 cellpadding=5 border=1 width=100% height=100%><tr><th>Source</th><th>Table</th></tr><td height=100% valign=top>";
//Get our libraries
$result = $db->query("SELECT gn_sourceitem.gn_label, gn_sourceitem.gn_order, gn_sourceitem.gn_iconSet, gn_domain.gn_name,gn_sourceitem.gn_controllerClassName,
  gn_sourceitem.gnpk, gn_sourceitem.gnguid FROM gn_sourceitem INNER JOIN gn_domain ON (gn_sourceitem.gn_domain=gn_domain.gnpk)
  where gn_sourceitem.gn_parent is null");
   //WHERE gn_sourceitem.gnent = 81 AND gn_sourceitem.gn_ControllerClassName IS NULL");
$counter=0;
while($row = $result->fetch(PDO::FETCH_ASSOC)) {
	if ($counter==0) {
		echo "<table border=1 cellspacing=5 cellpadding=5>\r";
		if ($libID == -1) $libID=$row["gnpk"];
		
	}
	if ($libID==$row["gnpk"]) {
		$libName = $row["gn_name"];
		$libFriendlyName = $row["gn_label"];
	}
	
	$imageType="Library";
	$libraryImageName = $row["gnpk"] .".png";
	GetLibraryImage($row["gnpk"],$row["gn_controllerClassName"],$row["gn_iconSet"]);
	$libType = $row["gn_controllerClassName"];
	$libIconSet = $row["gn_iconSet"];

	echo "<tr><td nowrap valign=middle nowrap><a href=index.php?lib=".$row["gnpk"].">";
	
	echo "<img align=\"absmiddle\" width=32 height=32 src=\"".$libraryImageName."\">";
	
	$dispname = $row["gn_label"];
	
	if ($dispname =="com.filemaker.bento.datasource.addressbook.contacts") {
		$dispname = "Address Book";
	}
	if ($dispname =="com.filemaker.bento.datasource.ical.events") {
		$dispname = "iCal Events";
	}
	if ($dispname =="com.filemaker.bento.datasource.ical.tasks") {
		$dispname = "iCal Tasks";
	}
	
	echo $dispname."</a></td></tr>\r";
	
	//Get collections (regular, not smart)
	$collresult = $db->query("SELECT gn_sourceitem.gn_label, gn_sourceitem.gn_order, gn_sourceitem.gn_iconSet, gn_domain.gn_name,gn_sourceitem.gn_ControllerClassName,
  		gn_sourceitem.gnpk, gn_sourceitem.gnguid FROM gn_sourceitem INNER JOIN gn_domain ON (gn_sourceitem.gn_domain=gn_domain.gnpk)
   		WHERE (gn_sourceitem.gn_parent = ".$row["gnpk"].")");

	while($collrow = $collresult->fetch(PDO::FETCH_ASSOC)) {
		$imageType="Collection";
		$collectionImageName = $row["gnpk"] .".png";
		GetCollectionImage($row["gnpk"],$libType,$libIconSet);
	
		echo "<tr><td nowrap>&nbsp;&nbsp;<a class=coll href=index.php?lib=".$row["gnpk"]."&coll=".$collrow["gnpk"].">";
		
		echo "<img align=\"absmiddle\" width=20 height=20 src=".$collectionImageName.">";
		
		
		echo $collrow["gn_label"]."</a></td></tr>\r";
		
		if ($collID==$collrow["gnpk"]) {
			$collFriendlyName = $collrow["gn_label"];
		}
	}
	
	$counter++;
}

if ($counter>0)  echo "</table>\r";

echo "</td><td width=100% height=100% valign=top>";
$fieldArray=array();

if ($collID == -1) {
	$tblID = $libID;
}
else {
	$tblID = $collID;
}

$sql = "SELECT gn_persistentstorage.gn_name FROM gn_domain 
	INNER JOIN gn_persistentstorage ON gn_domain.gnpk = gn_persistentstorage.gn_domain
	WHERE gn_domain.gn_sourceItem=".$libID;

$result = $db->query($sql);
$row = $result->fetch(PDO::FETCH_ASSOC);
$tblname = $row["gn_name"];

//Get the inverse table for collection records
if ($collID != -1) {
	$sql = "SELECT M_EntityDescription.gn_tableName, M_EntityDescription.gnpk, M_RelationshipDescription.gn_tablename, M_RelationshipDescription.gn_colName
	FROM M_EntityDescription INNER JOIN M_RelationshipDescription ON M_EntityDescription.gnpk = M_RelationshipDescription.gn_parent
	WHERE M_EntityDescription.gn_tableName=\"gn_".$tblname."\"";
	
	$inverseResult = $db->query($sql);
	$irrow = $inverseResult->fetch(PDO::FETCH_ASSOC);
	$inversetableName = $irrow["gn_tablename"];

	$inverseColName = $irrow["gn_colName"];
	$libFriendlyName.=" - " .$collFriendlyName;
	//
	$sql = "SELECT M_RelationshipDescription.gn_colName FROM M_RelationshipDescription
	WHERE M_RelationshipDescription.gn_tablename=\"".$inversetableName."\" AND
	M_RelationshipDescription.gn_destination=\"".$tblname."\"";

	$inverseColResult = $db->query($sql);
	$icrow = $inverseColResult->fetch(PDO::FETCH_ASSOC);
	$inverseRecResColName = $icrow["gn_colName"];
}

//Get the column headings
$result = $db->query("SELECT gn_field.gn_name, gn_field.gn_label,gn_field.gn_typeName, gn_field.gnpk
FROM gn_domain INNER JOIN gn_fielddisplay ON gn_domain.gn_displayContext = gn_fielddisplay.gn_displayContext
INNER JOIN gn_field ON gn_fielddisplay.gn_field = gn_field.gnpk
INNER JOIN gn_tablecolumn ON gn_fielddisplay.gnpk = gn_tablecolumn.gn_fieldDisplay
WHERE gn_domain.gn_sourceItem=".$tblID." AND gn_tablecolumn.gn_visible=1");
$libFriendlyName=str_replace("LibraryLabel_","",$libFriendlyName);
echo "<div id=\"libname\">".$libFriendlyName."</div>";
echo "<table class=\"sortable\" border=1 width=100% cellspacing=3 cellpadding=3>\r";
echo "<tr>";

$rowcount=0;
$sortcol="";

while($row = $result->fetch(PDO::FETCH_ASSOC)) {
$fixlabel = str_replace("FieldLabel_","",$row["gn_label"]);
	$fieldArray[$row["gn_name"]] = array($fixlabel=>$row["gn_typeName"]);
	echo "<th class=\"thsort\" id=\"".$row["gn_name"]."\">".$fixlabel ."</th>";
	if ($rowcount==0) $sortcol = $row["gn_name"];
	$rowcount++;
}

echo "</tr>\r";
//Get library records.  First get the table name
$sql = "SELECT gn_persistentstorage.gn_name,gn_domain.gn_controllerClassName FROM gn_domain 
	INNER JOIN gn_persistentstorage ON gn_domain.gnpk = gn_persistentstorage.gn_domain
	WHERE gn_domain.gn_sourceItem=".$libID;
	
$result = $db->query($sql);
$row = $result->fetch(PDO::FETCH_ASSOC);
$tblname = $row["gn_name"];
$libtype = $row["gn_controllerClassName"];
//Now get records
$sql = "SELECT * FROM gn_".$tblname;
//If needed limit to collection
if ($collID!=-1) {

	$rsql = "SELECT gn_domain.gn_persistentSubset
		FROM gn_sourceitem INNER JOIN gn_domain ON gn_sourceitem.gn_domain = gn_domain.gnpk
		WHERE gn_domain.gn_sourceItem=".$collID;
	
	$rResult = $db->query($rsql);
	$rrow = $rResult->fetch(PDO::FETCH_ASSOC);
	$persistentSubset = $rrow["gn_persistentSubset"];
	
	$sql .= " INNER JOIN ".$inversetableName." ON gn_".$tblname.".gnpk = ".$inversetableName.".".$inverseRecResColName
	. " WHERE ".$inverseColName."=".$persistentSubset;
	
}
 
if (strlen($sortcol)>0) $sql.=" ORDER BY gn_".$sortcol;

$result = $db->query($sql); 
$counter=0;
$colnum=0;
//Write record information
if ($result) {
	while($row = $result->fetch(PDO::FETCH_ASSOC)) {
		$colnum=0;
		$counter++;
		$mod = "td_".$counter % 2;
		$recordid =  $row["gnpk"];
		echo "<tr>";
		foreach ($fieldArray as $k=>$v) {
			$colname= "gn_".$k;
			$coltypeArr=array_values($v);
			$coltype = $coltypeArr[0];
			
			$colval = $row[$colname];
			
			if ($coltype=="com.filemaker.bento.field.core.date")$colval=phpDate($colval);
			if ($coltype=="com.filemaker.bento.field.private.timestamp.dateModified" | $coltype=="com.filemaker.bento.field.private.timestamp.dateCreated")$colval=phpDateTime($colval);
			if ($coltype=="com.filemaker.bento.field.core.checkbox")$colval=phpCB($colval);
			
			if ($colnum==0 & $allowShowDetails==1) {
				echo "<td class=$mod><a class=item href=# onclick=\"showform('$recordid','$tblname','$libID','$collID')\">".(strlen($colval)>0 ? $colval : "&nbsp;")."</a></td>";
			}
			else {
				echo "<td class=$mod>".(strlen($colval)>0 ? $colval : "&nbsp;")."</td>";
			}
			
			
			$colnum++;
		}
		echo "</tr>\r";
	}
}
//Close
echo "</table>\r";
echo "</tr>\r<tr><td class=copy colspan=2>Shokado Web Sharing $versionString Copyright &copy; 2008-2009 Mark Burgess. All Rights Reserved.</td></tr></table>\r";
?>
</body>
</html>